# template name attributes
%define slesver 15
%define	distrover sles
%define templatename sles
%define templatever %slesver
%define templatearch x86_64
%define technologies sysfs
%define distribution sles
# kernel from suse
%define osrelease 4.12.14
%define osenvironment YAST_IS_RUNNING=instsys

# Human-readable attributes
%define fullname SUSE Linux Enterprise Server %templatever
%define fulltemplatearch (for AMD64/Intel EM64T)

# template dirs
%define templatedir /vz/template/%templatename/%templatever/%templatearch/config
%define ostemplatedir %templatedir/os/default

# vzpkgenv related
%define pkgman zypp49x64
%define package_manager rpm%pkgman
%define package_manager_pkg vzpkgenv%pkgman >= 7.0.9

# Files lists
%define files_lst() \
find %1 -type d -printf '%%%dir %%%attr(%m,root,root) %p\\n' | sed "s,%buildroot,,g" >> %2\
find %1 -type f -printf '%%%config %%%attr(%m,root,root) %p\\n' | sed "s,%buildroot,,g" >> %2\
%nil

# Sources list
%define sources_lst() \
%((cd %_sourcedir;\
s=1;\
for tmpl in %*; do\
sources=$tmpl"_*";\
for file in $sources; do\
echo Source$s: $file;\
s=$((s+1))\
done;\
done))\
%nil

# Obsoletes list
%define obsoletes_lst() \
%((for tmpl in %*; do\
[ $tmpl = os ] && continue;\
echo "Obsoletes: $tmpl-%templatename-%templatever-%templatearch-ez < 7.0.0";\
echo "Provides: $tmpl-%templatename-%templatever-%templatearch-ez = %version-%release";\
done))\
%nil

# Templates list - packages file should be always present in any template!
%define templates_list() %((cd %_sourcedir; for f in *_packages; do echo -n "${f%_*} "; done))

Summary: %fullname %fulltemplatearch Template set
Name: %templatename-%templatever-%templatearch-ez
Group: Virtuozzo/Templates
License: GPL
Version: 8.0.0
Release: 1%{?dist}
BuildRoot: %_tmppath/%name-root
BuildArch: noarch
Requires: %package_manager_pkg

# template source files
%sources_lst %templates_list

# obsoletes
%obsoletes_lst %templates_list

%description
%fullname %fulltemplatearch packaged as a Virtuozzo Template set.

%install
installfile() {
	local sourcename=%_sourcedir/${1}_$4
	local mode=$2
	local dir=$3
	local name=$4

	[ ! -f $sourcename ] && return

	install -m $mode $sourcename $dir/$name
}

rm -f files.lst
for tmpl in %templates_list; do
	[ $tmpl = "os" ] && dir=%buildroot/%ostemplatedir || \
		dir=%buildroot/%templatedir/app/$tmpl/default

	mkdir -p $dir

	if [ $tmpl = "os" ]; then
		# Os template only files

		# Text
		echo "%fullname %fulltemplatearch Virtuozzo Template" > $dir/description
		echo "%fullname %fulltemplatearch Virtuozzo Template" > $dir/summary

		# Package manager
		echo "%package_manager" > $dir/package_manager
		echo "%technologies" > $dir/technologies
		# vzctl-related
		echo "%distribution" > $dir/distribution
		# Kernel virtualization
		echo "%osrelease" > $dir/osrelease

		# Disable upgrade
		touch $dir/upgradable_versions

		# Pkgman environment
		echo "%osenvironment" > $dir/environment

		# Os template cache scripts
		installfile $tmpl 0755 $dir pre-cache
		installfile $tmpl 0755 $dir post-cache
		installfile $tmpl 0755 $dir ct2vm
		installfile $tmpl 0755 $dir mid-pre-install
		installfile $tmpl 0755 $dir mid-post-install
		installfile $tmpl 0755 $dir pre-upgrade
		installfile $tmpl 0755 $dir post-upgrade
		# Installation sources
		echo '$SW_SERVER/download/mirrors/sles-%slesver-x86_64' >> $dir/mirrorlist
		echo '$SW_SERVER/download/mirrors/updates-released-sles%slesver-x86_64' >> $dir/mirrorlist
                # Release base
                echo 'https://updates.suse.com/SUSE/Products/SLE-Module-Basesystem/15/x86_64/product?$SLES_KEY_REL&ssl_capath=/vz/template/sles/15/x86_64/config/os/default/files/' >> $dir/repositories
		# Updates base
                echo 'https://updates.suse.com/SUSE/Updates/SLE-Module-Basesystem/15/x86_64/update?$SLES_KEY_UPD&ssl_capath=/vz/template/sles/15/x86_64/config/os/default/files/' >> $dir/repositories
		# release SLES 15
                echo 'https://updates.suse.com/SUSE/Products/SLE-Product-SLES/15/x86_64/product?$SLES_KEY_PRO&ssl_capath=/vz/template/sles/15/x86_64/config/os/default/files/' >> $dir/repositories
		# updates SLES 15
		echo 'https://updates.suse.com/SUSE/Updates/SLE-Product-SLES/15/x86_64/update?$SLES_KEY_PRU&ssl_capath=/vz/template/sles/15/x86_64/config/os/default/files/' >> $dir/repositories
		# sles server apps
		echo 'https://updates.suse.com/SUSE/Products/SLE-Module-Server-Applications/15/x86_64/product?$SLES_SERVER_REPO&ssl_capath=/vz/template/sles/15/x86_64/config/os/default/files/' >> $dir/repositories
		# sles server apps updates
		echo 'https://updates.suse.com/SUSE/Updates/SLE-Module-Server-Applications/15/x86_64/update?$SLES_SERVER_UPDATES&ssl_capath=/vz/template/sles/15/x86_64/config/os/default/files/' >> $dir/repositories
		# sles server web module scripting
		echo 'https://updates.suse.com/SUSE/Products/SLE-Module-Web-Scripting/15/x86_64/product?$SLES_KEY_WEB_PRO&ssl_capath=/vz/template/sles/15/x86_64/config/os/default/files/' >> $dir/repositories
		# sles server web module scripting updates
		echo 'https://updates.suse.com/SUSE/Updates/SLE-Module-Web-Scripting/15/x86_64/update?$SLES_KEY_WEB_UPD&ssl_capath=/vz/template/sles/15/x86_64/config/os/default/files/' >> $dir/repositories
		# sles server devtools
		echo 'https://updates.suse.com/SUSE/Products/SLE-Module-Development-Tools/15/x86_64/product?$SLES_KEY_DEV_PRO&ssl_capath=/vz/template/sles/15/x86_64/config/os/default/files/' >> $dir/repositories
		# sles server devtools updates
		echo 'https://updates.suse.com/SUSE/Updates/SLE-Module-Development-Tools/15/x86_64/update?$SLES_KEY_DEV_UPD&ssl_capath=/vz/template/sles/15/x86_64/config/os/default/files/' >> $dir/repositories
		# sles server legacy
		echo 'https://updates.suse.com/SUSE/Products/SLE-Module-Legacy/15/x86_64/product?$SLES_KEY_LEG_PRO&ssl_capath=/vz/template/sles/15/x86_64/config/os/default/files/' >> $dir/repositories
		# sles server legacy updates
		echo 'https://updates.suse.com/SUSE/Updates/SLE-Module-Legacy/15/x86_64/update?$SLES_KEY_LEG_UPD&ssl_capath=/vz/template/sles/15/x86_64/config/os/default/files/' >> $dir/repositories
		# how to obtain it
		# trust extract --format=openssl-directory --filter=ca-anchors --overwrite /tmp/certs/
		# pick 3513523f.0
		mkdir -p $dir/files/
		echo "-----BEGIN CERTIFICATE-----
MIIDrzCCApegAwIBAgIQCDvgVpBCRrGhdWrJWZHHSjANBgkqhkiG9w0BAQUFADBh
MQswCQYDVQQGEwJVUzEVMBMGA1UEChMMRGlnaUNlcnQgSW5jMRkwFwYDVQQLExB3
d3cuZGlnaWNlcnQuY29tMSAwHgYDVQQDExdEaWdpQ2VydCBHbG9iYWwgUm9vdCBD
QTAeFw0wNjExMTAwMDAwMDBaFw0zMTExMTAwMDAwMDBaMGExCzAJBgNVBAYTAlVT
MRUwEwYDVQQKEwxEaWdpQ2VydCBJbmMxGTAXBgNVBAsTEHd3dy5kaWdpY2VydC5j
b20xIDAeBgNVBAMTF0RpZ2lDZXJ0IEdsb2JhbCBSb290IENBMIIBIjANBgkqhkiG
9w0BAQEFAAOCAQ8AMIIBCgKCAQEA4jvhEXLeqKTTo1eqUKKPC3eQyaKl7hLOllsB
CSDMAZOnTjC3U/dDxGkAV53ijSLdhwZAAIEJzs4bg7/fzTtxRuLWZscFs3YnFo97
nh6Vfe63SKMI2tavegw5BmV/Sl0fvBf4q77uKNd0f3p4mVmFaG5cIzJLv07A6Fpt
43C/dxC//AH2hdmoRBBYMql1GNXRor5H4idq9Joz+EkIYIvUX7Q6hL+hqkpMfT7P
T19sdl6gSzeRntwi5m3OFBqOasv+zbMUZBfHWymeMr/y7vrTC0LUq7dBMtoM1O/4
gdW7jVg/tRvoSSiicNoxBN33shbyTApOB6jtSj1etX+jkMOvJwIDAQABo2MwYTAO
BgNVHQ8BAf8EBAMCAYYwDwYDVR0TAQH/BAUwAwEB/zAdBgNVHQ4EFgQUA95QNVbR
TLtm8KPiGxvDl7I90VUwHwYDVR0jBBgwFoAUA95QNVbRTLtm8KPiGxvDl7I90VUw
DQYJKoZIhvcNAQEFBQADggEBAMucN6pIExIK+t1EnE9SsPTfrgT1eXkIoyQY/Esr
hMAtudXH/vTBH1jLuG2cenTnmCmrEbXjcKChzUyImZOMkXDiqw8cvpOp/2PV5Adg
06O/nVsJ8dWO41P0jmP6P6fbtGbfYmbW0W5BjfIttep3Sp+dWOIrWcBAI+0tKIJF
PnlUkiaY4IBIqDfv8NZ5YBberOgOzW6sRBc4L0na4UU+Krk2U886UAb3LujEV0ls
YSEY1QSteDwsOoBrp+uvFRTp2InBuThs4pFsiv9kuXclVzDAGySj4dzp30d8tbQk
CAUw7C29C79Fv1C5qfPrmAESrciIxpg0X40KPMbp1ZWVbd4wLzAUBggrBgEFBQcD
BAYIKwYBBQUHAwEMF0RpZ2lDZXJ0IEdsb2JhbCBSb290IENB
-----END CERTIFICATE-----" > $dir/files/3513523f.0
	else
		# App templates only files

		# Text
		echo "$tmpl for %fullname %fulltemplatearch Virtuozzo Template" > $dir/description
		echo "$tmpl for %fullname %fulltemplatearch Virtuozzo Template" > $dir/summary
	fi

	# Common things
	# Packages
	installfile $tmpl 0644 $dir packages

	# Scripts
	installfile $tmpl 0755 $dir pre-install
	installfile $tmpl 0755 $dir pre-install-hn
	installfile $tmpl 0755 $dir post-install
	installfile $tmpl 0755 $dir post-install-hn

	# Versioning
	echo "%release" > $dir/release
	echo "%version" > $dir/version
	%files_lst $dir files.lst
done

%files -f files.lst

%changelog
* Wed Aug 21 2019 Alexander Stefanov <astefanov@virtuozzo.com> 7.0.0-4
- fix #PSBM-96505, remove double "="

* Thu Aug  1 2019 Alexander Stefanov <astefanov@virtuozzo.com> 7.0.0-3
- fix #PSBM-96505

* Tue Jan 22 2019 Konstantin Volkov <wolf@virtuozzo.com> 7.0.0-2
- Added proper /sbin/init, see #PSBM-90801
- Correct post install/cache scripts
- Correct osrelease
- Fixed modules_dep script execution
- Added modules repos, see #PSBM-90788
- Fixed devel app template pkg list
- Removed mailman, mod_perl and webalizer apptemplates (all dropped from SLES repos)
- Postgresql updated to version 10

* Mon Aug 20 2018 Alexander Stefanov <astefanov@virtuozzo.com> 7.0.0-1
- Initial release
